//+------------------------------------------------------------------+
//|                                            Trade SpeedoMETER.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Red 
#property indicator_width1 1
#property indicator_width2 1
 
extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern string soundfile        = "alert2.wav";
extern int    arrowSize        = 2;


double CrossUp[];
double CrossDn[];
double trend[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(3);  
   SetIndexBuffer(0,CrossUp); SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,159);
   SetIndexBuffer(1,CrossDn); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,159);
   SetIndexBuffer(2,trend); 
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
  
  
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (int i=limit; i>=0; i--)
   {
      double OpenPricenow  = Open[i];
      double ClosePricenow = Close[i];
      double Volumenow     = Volume[i]+1;
   
   // candle 1
   double OpenPrice1  = Open [i+1];
   double ClosePrice1 = Close [i+1];
   double Volume1     = Volume[i+1]+1;
   
   
   // candle 2
   double OpenPrice2  = Open[i+2];
   double ClosePrice2 = Close[i+2];
   double Volume2     = Volume[i+2]+1;
   
   
   
   
   // candle 3
   double OpenPrice3  = Open[i+3];
   double ClosePrice3 = Close[i+3];
   double Volume3     = Volume[i+3]+1;
   
   // candle 4
   
   double OpenPrice4  = Open[i+4];
   double ClosePrice4 = Close[i+4];
   double Volume4     = Volume[i+4]+1;
   
   
   
   //  candle 5
   
   double OpenPrice5  = Open[i+5];
   double ClosePrice5 = Close[i+5];
   double Volume5     = Volume[i+5]+1;
   
   
   //  candle 6
   
   double OpenPrice6  = Open[i+6];
   double ClosePrice6 = Close[i+6];
   double Volume6     =  Volume[i+6]+1;
   
   
   //  candle 7 
   
   double OpenPrice7  = Open[i+7];
   double ClosePrice7 = Close[i+7];
   double Volume7     = Volume[i+7]+1;
   
   
   //  candle 8 
   
   double OpenPrice8  = Open[i+8];
   double ClosePrice8 = Close[i+8];
   double Volume8     = Volume[i+8]+1;
   
   
   // candle 9
   
   double OpenPrice9  = Open[i+9];
   double ClosePrice9 = Close[i+9];
   double Volume9     = Volume[i+9]+1;
   
   
   // candle 10
   
   double OpenPrice10  = Open[i+10];
   double ClosePrice10 = Close[i+10];
   double Volume10     = Volume[i+10]+1;
   
   // candle 11
   
   double OpenPrice11  = Open[i+11];
   double ClosePrice11 = Close[i+11];
   double Volume11     = Volume[i+11]+1;
   
   // candle 12
   
   double OpenPrice12  = Open[i+12];
   double ClosePrice12 = Close[i+12];
   double Volume12     = Volume[i+12]+1;
   
   // candle 13
   
   double OpenPrice13  = Open [i+13];
   double ClosePrice13 = Close[i+13];
   double Volume13     = Volume[i+13]+1;
   
   // candle 14
   
   double OpenPrice14  = Open [i+14];
   double ClosePrice14 = Close[i+14];
   double Volume14     = Volume[i+14]+1;
   
   
   
   double pnow = (ClosePricenow - OpenPricenow); 
   double SOT  =  (pnow / Volumenow)*10000;
   
   
   double p1   = (ClosePrice1 - OpenPrice1);
   double SOT1 = (p1 / Volume1) *10000;
   
   
   double p2   = (ClosePrice2 - OpenPrice2);
   double SOT2 = (p2 / Volume2) *10000;
   
   
   double p3 = (ClosePrice3 - OpenPrice3);
   double SOT3 = (p3 / Volume3) *10000;
   
   
   double p4 = (ClosePrice4 - OpenPrice4);
   double SOT4= (p4 / Volume4) *10000;
   
   
   double p5 = (ClosePrice5 - OpenPrice5);
   double SOT5 = (p5 / Volume5) *10000;
   
   
   double p6 = (ClosePrice6 - OpenPrice6);
   double SOT6 = (p6 / Volume6) *10000;
   
   
   double p7 = (ClosePrice7 - OpenPrice7);
   double SOT7 = (p7 / Volume7) *10000;
   
   
   double p8 = (ClosePrice8 - OpenPrice8);
   double SOT8 = (p8 / Volume8) *10000;
   
   
   double p9 = (ClosePrice9 - OpenPrice9);
   double SOT9 = (p9 / Volume9) *10000;
   
   double p10 = (ClosePrice10 - OpenPrice10);
   double SOT10 = (p10 / Volume10) *10000;
   
   double p11 = (ClosePrice11 - OpenPrice11);
   double SOT11 = (p11 / Volume11) *10000;
   
   double p12 = (ClosePrice12 - OpenPrice12);
   double SOT12 = (p12 / Volume12) *10000;
   
   double p13 = (ClosePrice13 - OpenPrice13);
   double SOT13 = (p13 / Volume13) *10000;
   
   double p14 = (ClosePrice14 - OpenPrice14);
   double SOT14 = (p14 / Volume14) *10000;
   
   double SOTAV10 = ((SOT1+SOT2+SOT3+SOT4+SOT5+SOT6+SOT7+SOT8+SOT9+SOT10+SOT11+SOT12+SOT13+SOT14/100)*14);
   double SOTAV2 = (SOTAV10*2);
   
         trend[i] = trend[i+1]; 
         if ((SOT>SOTAV2) && (ClosePrice1<OpenPrice1) && (ClosePricenow<OpenPrice1))   trend[i] = 1;
         if ((SOT>SOTAV2) && (ClosePrice1>OpenPrice1) && (ClosePricenow>OpenPricenow)) trend[i] =-1;
   
         //
         //
         //
         //
         //
      
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i]!= trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] = Low[i]  - iATR(NULL,0,20,i)/2;
         else  CrossDn[i] = High[i] + iATR(NULL,0,20,i)/2;
         }
          
          //
          //
          //
          //
          //
      
          if (alertsOn)
          {
          if (alertsOnCurrent)
               int whichBar = 0;
          else     whichBar = 1;
          if (trend[whichBar] != trend[whichBar+1])
          if (trend[whichBar] == 1)
                doAlert("Buy");
          else  doAlert("Sell");       
   }

return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SOT_DOT ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SOT_DOT "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
        
  
  
  
  
  
  
  
  



